package com.tzld.piaoquan.ad.engine.commons.util;

import com.alibaba.fastjson.JSONObject;
import com.google.common.reflect.TypeToken;
import com.google.gson.Gson;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class JSONUtils {

    private static final Logger log = LoggerFactory.getLogger(JSONUtils.class);
    public static String toJson(Object obj) {
        if (obj == null) {
            return "";
        }
        try {
            return new Gson().toJson(obj);
        } catch (Exception e) {
            log.error("toJson exception", e);
            return "";
        }
    }

    public static <T> T fromJson(String value, TypeToken<T> typeToken, T defaultValue) {

        if (StringUtils.isBlank(value)) {
            return defaultValue;
        }
        try {
            return JSONObject.parseObject(value, typeToken.getType());
        } catch (Exception e) {
            log.error("parseObject error! value=[{}]", value, e);
        }
        return defaultValue;
    }

}
