package com.tzld.piaoquan.ad.engine.server.controller;

import com.tzld.piaoquan.ad.engine.service.score.RankService;
import com.tzld.piaoquan.ad.engine.service.score.dto.AdPlatformCreativeDTO;
import com.tzld.piaoquan.ad.engine.service.score.param.BidRankRecommendRequestParam;
import com.tzld.piaoquan.ad.engine.service.score.param.RankRecommendRequestParam;
import com.tzld.piaoquan.recommend.feature.domain.ad.base.AdRankItem;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("/recommend")
public class AdRecommendController {

    private final static Logger log = LoggerFactory.getLogger(AdRecommendController.class);
    @Autowired
    @Qualifier("rankServiceImpl")
    RankService rankService;

    @RequestMapping("/top1/basic")
    public Map<String,Object> adRecommendTop1Basic(@RequestBody RankRecommendRequestParam request){
        AdRankItem rankResult = rankService.adItemRank(request);
        HashMap map =new HashMap();
        map.put("code","0");
        map.put("msg","success");
        HashMap contentMap=new HashMap<>();
        contentMap.put("adId", rankResult.getAdId());
        contentMap.put("adScore", rankResult.getScore());
        map.put("content",contentMap);
        return map;
    }

    @RequestMapping("/top1/video/ad/thompson")
    public Map<String,Object> adRecommendTop1VideoAdThompson(@RequestBody RankRecommendRequestParam request){
        AdRankItem rankResult = rankService.adItemRankWithVideoAdThompson(request);
        HashMap map =new HashMap();
        map.put("code","0");
        map.put("msg","success");
        HashMap contentMap=new HashMap<>();
        contentMap.put("adId", rankResult.getAdId());
        contentMap.put("adScore", rankResult.getScore());
        map.put("content",contentMap);
        return map;
    }

    @RequestMapping("/top1/bid/basic")
    public Map<String,Object> adRecommendTop1BidBasic(@RequestBody BidRankRecommendRequestParam request){
        AdPlatformCreativeDTO rankResult = rankService.adBidRank(request);
        HashMap map =new HashMap();
        map.put("code","0");
        map.put("msg","success");
        map.put("content",rankResult);
        return map;
    }

    @RequestMapping("/top1/bid/new/pid")
    public Map<String,Object> adRecommendTop1BidNewPid(@RequestBody BidRankRecommendRequestParam request){
        AdPlatformCreativeDTO rankResult = rankService.adBidRankNewPid(request);
        HashMap map =new HashMap();
        map.put("code","0");
        map.put("msg","success");
        map.put("content",rankResult);
        return map;
    }

}
